// foo_notaskbar.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

/*
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}
*/

DECLARE_COMPONENT_VERSION(
	"Taskbar Button Remover",	// component name

	"0.1",						// component version

	"Removes Foobar2000's taskbar button, even when its window is visible.\n"
	"For foobar2000 v0.8\n"
	"Hack thrown together by Leo 'Nudel' Davidson\n"
	"Simple source available from www.PretentiousName.com")

LONG_PTR g_pOldWProcMain = NULL;
UINT g_uiWM_PostEvent = 0;

LRESULT CALLBACK g_NewWProcMain(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (NULL == g_pOldWProcMain)
	{
		return(0);
	}

	LRESULT lResult = CallWindowProc(reinterpret_cast<WNDPROC>(g_pOldWProcMain), hWnd, message, wParam, lParam);

	if (g_uiWM_PostEvent != 0)
	{
		//if (message == WM_SIZE && (wParam == SIZE_MAXIMIZED || wParam == SIZE_RESTORED))
		//if (message == WM_ACTIVATE)
		if (message == WM_NCACTIVATE)
		{
			PostMessage(hWnd, g_uiWM_PostEvent, 0, 0);
		}
		else if (message == g_uiWM_PostEvent)
		{
			// Presumably ITaskbarList is implemented by Explorer.exe, so we shouldn't create it once and hang onto it forever
			// since if Explorer crashes or is restarted the interface won't work anymore. Not sure, but doing it this way is harmless, anyway.
			ITaskbarList *pTaskbarList = NULL;

			if (SUCCEEDED(CoCreateInstance(CLSID_TaskbarList,0,CLSCTX_INPROC_SERVER,IID_ITaskbarList,reinterpret_cast<void**>(&pTaskbarList)))
			&&	NULL != pTaskbarList)
			{
				if (SUCCEEDED(pTaskbarList->HrInit()))
				{
					pTaskbarList->DeleteTab(hWnd);
				}
				pTaskbarList->Release();
			}
		}
	}

	return(lResult);
}

void g_subclassMainFoobarWindow()
{
	HWND hWnd = core_api::get_main_window();

	if (NULL != hWnd && IsWindow(hWnd))
	{
		g_pOldWProcMain = SetWindowLongPtr(hWnd, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(g_NewWProcMain));
	}
}

void g_unsubclassMainFoobarWindow()
{
	HWND hWnd = core_api::get_main_window();

	if (NULL != g_pOldWProcMain && NULL != hWnd && IsWindow(hWnd))
	{
		SetWindowLongPtr(hWnd, GWLP_WNDPROC, g_pOldWProcMain);
	}
}

class initquit_notaskbar : public initquit
{
	virtual void on_init()
	{
		// Changing the main fb2k window to a ToolWindow is more reliable, and a one-off operation, but tool window's
		// look so ugly... The alternative is to make the main window owned by a hidden parent but I don't think that's
		// possible since plugins start after the window has already been created.
		// So we go with the Subclass and ITaskbarList approach...

		//HWND hWnd = core_api::get_main_window();
		//if (NULL != hWnd)
		//{
		//	LONG_PTR ExStyle = GetWindowLongPtr(hWnd, GWL_EXSTYLE);
		//	ExStyle &= ~WS_EX_APPWINDOW;
		//	ExStyle |= WS_EX_TOOLWINDOW;
		//	ShowWindow(hWnd, SW_HIDE);
		//	SetWindowLongPtr(hWnd, GWL_EXSTYLE, ExStyle);
		//	ShowWindow(hWnd, SW_SHOW);
		//	ExStyle &= ~WS_EX_TOOLWINDOW;
		//	SetWindowLongPtr(hWnd, GWL_EXSTYLE, ExStyle);
		//}

		CoInitialize(NULL); // Just in case fb2k doesn't init COM by itself. (It seems to, or some other component does.)

		g_uiWM_PostEvent = RegisterWindowMessage("foo_notaskbar_postevent_{4CD4EC6E-EE11-4df9-8F93-E10D3E08BFC9}");
		g_subclassMainFoobarWindow();
	}

	virtual void on_quit()
	{
		g_unsubclassMainFoobarWindow();

		CoUninitialize();
	}

	virtual void on_system_shutdown()
	{
		on_quit();
	}
};

static initquit_factory< initquit_notaskbar > foo_initquit;
